Index: testsuites/smptests/smplock01/init.c
===================================================================
--- testsuites/smptests/smplock01/init.c	(revision db20706d5ab05172d14156d4f9aaf68ff461645a)
+++ testsuites/smptests/smplock01/init.c	(revision a6283671f31498773d0842b43884048c8d2d61fd)
@@ -32,5 +32,5 @@
 #define CPU_COUNT 32
 
-#define TEST_COUNT 11
+#define TEST_COUNT 13
 
 typedef struct {
@@ -38,13 +38,14 @@
   unsigned long counter[TEST_COUNT];
   unsigned long local_counter[CPU_COUNT][TEST_COUNT][CPU_COUNT];
-  SMP_lock_Control lock;
+  SMP_lock_Control lock RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
+  Atomic_Uint flag RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
+  SMP_MCS_lock_Control mcs_lock RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
 #if defined(RTEMS_PROFILING)
   SMP_lock_Stats mcs_stats;
 #endif
-  SMP_MCS_lock_Control mcs_lock;
-  SMP_sequence_lock_Control seq_lock;
+  SMP_sequence_lock_Control seq_lock RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
   int a RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
   int b RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
-} test_context RTEMS_ALIGNED(CPU_CACHE_LINE_BYTES);
+} test_context;
 
 static test_context test_instance = {
@@ -53,4 +54,5 @@
   .mcs_stats = SMP_LOCK_STATS_INITIALIZER("global MCS"),
 #endif
+  .flag = ATOMIC_INITIALIZER_UINT(0),
   .mcs_lock = SMP_MCS_LOCK_INITIALIZER,
   .seq_lock = SMP_SEQUENCE_LOCK_INITIALIZER
@@ -588,4 +590,84 @@
 }
 
+static void test_11_body(
+  rtems_test_parallel_context *base,
+  void *arg,
+  size_t active_workers,
+  size_t worker_index
+)
+{
+  test_context *ctx = (test_context *) base;
+  size_t test = 11;
+  unsigned long counter = 0;
+
+  while (!rtems_test_parallel_stop_job(&ctx->base)) {
+    while (_Atomic_Exchange_uint(&ctx->flag, 1, ATOMIC_ORDER_ACQUIRE) != 0) {
+      /* Wait */
+    }
+
+    _Atomic_Store_uint(&ctx->flag, 0, ATOMIC_ORDER_RELEASE);
+    ++counter;
+  }
+
+  ctx->local_counter[active_workers - 1][test][worker_index] = counter;
+}
+
+static void test_11_fini(
+  rtems_test_parallel_context *base,
+  void *arg,
+  size_t active_workers
+)
+{
+  test_context *ctx = (test_context *) base;
+
+  test_fini(
+    ctx,
+    "GlobalTASLockWithLocalCounter",
+    11,
+    active_workers
+  );
+}
+
+static void test_12_body(
+  rtems_test_parallel_context *base,
+  void *arg,
+  size_t active_workers,
+  size_t worker_index
+)
+{
+  test_context *ctx = (test_context *) base;
+  size_t test = 12;
+  unsigned long counter = 0;
+
+  while (!rtems_test_parallel_stop_job(&ctx->base)) {
+    while (_Atomic_Exchange_uint(&ctx->flag, 1, ATOMIC_ORDER_ACQUIRE) != 0) {
+      while (_Atomic_Load_uint(&ctx->flag, ATOMIC_ORDER_RELAXED) != 0) {
+        /* Wait */
+      }
+    }
+
+    _Atomic_Store_uint(&ctx->flag, 0, ATOMIC_ORDER_RELEASE);
+    ++counter;
+  }
+
+  ctx->local_counter[active_workers - 1][test][worker_index] = counter;
+}
+
+static void test_12_fini(
+  rtems_test_parallel_context *base,
+  void *arg,
+  size_t active_workers
+)
+{
+  test_context *ctx = (test_context *) base;
+
+  test_fini(
+    ctx,
+    "GlobalTTASLockWithLocalCounter",
+    12,
+    active_workers
+  );
+}
+
 static const rtems_test_parallel_job test_jobs[TEST_COUNT] = {
   {
@@ -644,4 +726,14 @@
     .fini = test_10_fini,
     .cascade = false
+  }, {
+    .init = test_init,
+    .body = test_11_body,
+    .fini = test_11_fini,
+    .cascade = true
+  }, {
+    .init = test_init,
+    .body = test_12_body,
+    .fini = test_12_fini,
+    .cascade = true
   }
 };
Index: testsuites/smptests/smplock01/smplock01fair.py
===================================================================
--- testsuites/smptests/smplock01/smplock01fair.py	(revision a6283671f31498773d0842b43884048c8d2d61fd)
+++ testsuites/smptests/smplock01/smplock01fair.py	(revision a6283671f31498773d0842b43884048c8d2d61fd)
@@ -0,0 +1,58 @@
+#!/usr/bin/env python
+
+#
+# Copyright (c) 2016 embedded brains GmbH.  All rights reserved.
+#
+# The license and distribution terms for this file may be
+# found in the file LICENSE in this distribution or at
+# http://www.rtems.org/license/LICENSE.
+#
+
+import re
+import libxml2
+import math
+import statistics
+from libxml2 import xmlNode
+import matplotlib.pyplot as plt
+data = open('smplock01.scn').read()
+data = re.sub(r'\*\*\*.*\*\*\*', '', data)
+doc = libxml2.parseDoc(data)
+ctx = doc.xpathNewContext()
+
+plt.title('SMP Lock Fairness')
+plt.xlabel('Active Workers')
+plt.ylabel('Normed Coefficient of Variation')
+
+i = 1
+ticket = []
+mcs = []
+tas = []
+ttas = []
+
+def m(n):
+	return int(xmlNode.getContent(n))
+
+def normedCoefficientOfVariation(name, i):
+	y = map(m, ctx.xpathEval('/SMPLock01/' + name + '[@activeWorker=' + str(i) + ']/LocalCounter'))
+	if len(y) == 0:
+		raise
+	return (statistics.stdev(y) / statistics.mean(y)) / math.sqrt(len(y) - 1)
+
+try:
+	while True:
+		i = i + 1
+		ticket.append(normedCoefficientOfVariation('GlobalTicketLockWithLocalCounter', i))
+		mcs.append(normedCoefficientOfVariation('GlobalMCSLockWithLocalCounter', i))
+		tas.append(normedCoefficientOfVariation('GlobalTASLockWithLocalCounter', i))
+		ttas.append(normedCoefficientOfVariation('GlobalTTASLockWithLocalCounter', i))
+except:
+	pass
+
+x = range(1, len(ticket) + 1)
+plt.yscale('log')
+plt.plot(x, ticket, label = 'Ticket Lock', marker = 'o')
+plt.plot(x, mcs, label = 'MCS Lock', marker = 'o')
+plt.plot(x, tas, label = 'TAS Lock', marker = 'o')
+plt.plot(x, ttas, label = 'TTAS Lock', marker = 'o')
+plt.legend(loc = 'best')
+plt.show()
Index: testsuites/smptests/smplock01/smplock01perf.py
===================================================================
--- testsuites/smptests/smplock01/smplock01perf.py	(revision a6283671f31498773d0842b43884048c8d2d61fd)
+++ testsuites/smptests/smplock01/smplock01perf.py	(revision a6283671f31498773d0842b43884048c8d2d61fd)
@@ -0,0 +1,38 @@
+#!/usr/bin/env python
+
+#
+# Copyright (c) 2016 embedded brains GmbH.  All rights reserved.
+#
+# The license and distribution terms for this file may be
+# found in the file LICENSE in this distribution or at
+# http://www.rtems.org/license/LICENSE.
+#
+
+import re
+import libxml2
+from libxml2 import xmlNode
+import matplotlib.pyplot as plt
+data = open('smplock01.scn').read()
+data = re.sub(r'\*\*\*.*\*\*\*', '', data)
+doc = libxml2.parseDoc(data)
+ctx = doc.xpathNewContext()
+
+plt.title('SMP Lock Performance')
+plt.xlabel('Active Workers')
+plt.ylabel('Operation Count')
+
+y = map(xmlNode.getContent, ctx.xpathEval('/SMPLock01/GlobalTicketLockWithLocalCounter/SumOfLocalCounter'))
+x = range(1, len(y) + 1)
+plt.plot(x, y, label = 'Ticket Lock', marker = 'o')
+
+y = map(xmlNode.getContent, ctx.xpathEval('/SMPLock01/GlobalMCSLockWithLocalCounter/SumOfLocalCounter'))
+plt.plot(x, y, label = 'MCS Lock', marker = 'o')
+
+y = map(xmlNode.getContent, ctx.xpathEval('/SMPLock01/GlobalTASLockWithLocalCounter/SumOfLocalCounter'))
+plt.plot(x, y, label = 'TAS Lock', marker = 'o')
+
+y = map(xmlNode.getContent, ctx.xpathEval('/SMPLock01/GlobalTTASLockWithLocalCounter/SumOfLocalCounter'))
+plt.plot(x, y, label = 'TTAS Lock', marker = 'o')
+
+plt.legend(loc = 'best')
+plt.show()
